unit Unit3; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Process,
  pea_utils,ansiutf8_utils, Buttons, ButtonPanel, EditBtn, Menus;

type

  { TForm2 }

  TForm2 = class(TForm)
    ButtonEditName3: TButton;
    ButtonEditName4: TSpeedButton;
    ButtonPanel1: TButtonPanel;
    EditName3: TEdit;
    EditUn7zaPW: TEdit;
    LableListPath1: TLabel;
    LableListPath2: TLabel;
    mpwreset: TMenuItem;
    mpwexplore: TMenuItem;
    OpenDialogKF: TOpenDialog;
    PanelPWOpen: TPanel;
    PopupMenupw: TPopupMenu;
    procedure ButtonEditName3Click(Sender: TObject);
    procedure ButtonEditName4Click(Sender: TObject);
    procedure EditUn7zaPWKeyPress(Sender: TObject; var Key: char);
    procedure FormCreate(Sender: TObject);
    procedure mpwexploreClick(Sender: TObject);
    procedure mpwresetClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form2: TForm2;
  desk_env,showpwfield:byte;
  caption_build,delimiter,wincomspec,winver,validate_txt:utf8string;

implementation

{ TForm2 }

procedure TForm2.EditUn7zaPWKeyPress(Sender: TObject; var Key: char);
begin
if Key=char(13) then
   begin
   Form2.Close;
   Form2.ModalResult:=1;
   end;
end;

procedure TForm2.ButtonEditName4Click(Sender: TObject);
var p:tpoint;
begin
p.x:=buttoneditname4.left;
p.y:=buttoneditname4.top+buttoneditname4.height;
p:=clienttoscreen(p);
popupmenupw.popup(p.x,p.y);
end;

procedure TForm2.ButtonEditName3Click(Sender: TObject);
begin
if OpenDialogKF.Execute then
   if OpenDialogKF.FileName<>'' then EditName3.Text:=OpenDialogKF.FileName
   else exit
else exit;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
getdesk_env(desk_env,caption_build,delimiter);
{$IFDEF MSWINDOWS}
getwinenv(wincomspec,winver);
{$ENDIF}
end;

//open, cross platform, with sanitization of string passed to the function
function cp_open(s:utf8string; desk_env:byte):integer;
var
   w:widestring;
   P:TProcess;
begin
cp_open:=-1;
if s='' then exit;
if validatecl(s)<>0 then begin MessageDlg(validate_txt+' '+s, mtWarning, [mbOK], 0); exit; end;
{$IFDEF MSWINDOWS}
w:=utf8decode(s);
P:=TProcess.Create(nil);
P.Options := [poNoConsole];
if w[1]=utf8decode(delimiter) then
else w:=utf8encode(delimiter)+w+utf8encode(delimiter);
if winver<>'9x' then P.CommandLine:=wincomspec+' /c start "" '+w
else P.CommandLine:=wincomspec+' /c start '+w;
P.Execute;
P.Free;
cp_open:=0;
{$ENDIF}
{$IFDEF LINUX}cp_open:=cp_open_linuxlike(s,desk_env);{$ENDIF}//try to open via Gnome or KDE
{$IFDEF FREEBSD}cp_open:=cp_open_linuxlike(s,desk_env);{$ENDIF}
{$IFDEF NETBSD}cp_open:=cp_open_linuxlike(s,desk_env);{$ENDIF}
end;

procedure TForm2.mpwexploreClick(Sender: TObject);
var
   s:utf8string;
begin
s:=uextractfilepath(EditName3.Text);
cp_open(s,desk_env);
end;

procedure TForm2.mpwresetClick(Sender: TObject);
begin
EditName3.Text:='';
end;

initialization
  {$I unit3.lrs}

end.

